;; Copyright Idiomdrottning, I don't know when I wrote the following
;; code. Years and years ago! I place it in the public domain. CC-0.

;; For a repo, louk git clone https://idiomdrottning.org/do-thing-at-point.el


(defun string-to-numeronym (word)
  "Let the second brain do the counting! (Convert strings to their numeronym equivalent.)"
  (let ((l (length word)))
    (concat (substring word 0 1) (number-to-string (- l 2)) (substring word (- l 1) l))))

(defun numeronym-at-point ()
  "Replace the word at point in the buffer with its n7m equivalent."
  (interactive)
  (do-thing-at-point #'string-to-numeronym))

(defun increment-here ()
  "Replace the number at point in the buffer incremented by one"
  (interactive)
  (do-thing-at-point #'(lambda (word) (number-to-string (+ (string-to-number word) 1)))))

(defun decrement-here ()
  "Replace the number at point in the buffer decremented by one"
  (interactive)
  (do-thing-at-point #'(lambda (word) (number-to-string (- (string-to-number word) 1)))))

(defun do-thing-at-point (proc)
  "Skeletal function. Do something to the word at point."
  (save-excursion
    (backward-word)
    (let ((start (point)))
      (forward-word)
      (let ((word (buffer-substring-no-properties start (point))))
	(delete-region start (point))
	(insert (funcall proc word))
	(forward-word)))))
